package com.logntw.eva.jdbc;


public final class SQLType implements Comparable<SQLType>
{
	private final boolean indexable; 
	private final String name;
	public SQLType(boolean indexable, String name)
	{
		if(name == null)
			throw new java.lang.IllegalStateException("[jCISe1001]");
		this.indexable = indexable;
		this.name = name;
	}
	
	public boolean indexable()
	{
		return indexable;
	}
	
	public String name()
	{
		return name;
	}
	
	@Override
	public int hashCode()
	{
		return name.hashCode();
	}
	
	@Override
	public String toString()
	{
		return name;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		if(!(obj instanceof SQLType))
			return false;
		SQLType that = (SQLType) obj;
		return indexable == that.indexable && name.equals(that.name);
	}

	@Override
	public int compareTo(SQLType o)
	{
		if(indexable)
		{
			if(o.indexable)
				return name.compareTo(o.name);
			else
				return -1;
		}
		else
		{
			if(!o.indexable)
				return name.compareTo(o.name);
			else
				return 1;
		}
	}
}
