package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Access_7_0_Dialect;
import com.logntw.eva.sql.dialect.Dialect;

public class Access_7_0ConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCIAr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "sun.jdbc.odbc.JdbcOdbcDriver";
	}
		
	public Access_7_0ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public Access_7_0ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public Access_7_0ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI, String id, String password) throws SQLException
	{
		super(factory, databaseNameOrURI, id, password);
	}
	
	public Access_7_0ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:odbc:Driver={MicroSoft Access Driver (*.mdb)};DBQ=";
	}
	
	@Override
	public Dialect getDialect()
	{
		return Access_7_0_Dialect.INSTANCE;
	}
}
