package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.DB2_Dialect;
import com.logntw.eva.sql.dialect.Dialect;

public class DB2ConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("com.ibm.db2.jdbc.app.DB2Driver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCIDr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "com.ibm.db2.jdbc.app.DB2Driver";
	}
		
	public DB2ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public DB2ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public DB2ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public DB2ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:db2:";
	}
	
	@Override
	public Dialect getDialect()
	{
		return DB2_Dialect.INSTANCE;
	}
}