package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Dialect;
import com.logntw.eva.sql.dialect.HSQLDB_1_8_Dialect;

// Connection pool?
public class HSQLDB_1_8ConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("org.hsqldb.jdbcDriver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCIHr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "org.hsqldb.jdbcDriver";
	}
	
	public HSQLDB_1_8ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public HSQLDB_1_8ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public HSQLDB_1_8ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public HSQLDB_1_8ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public Dialect getDialect()
	{
		return HSQLDB_1_8_Dialect.INSTANCE;
	}
			
	@Override
	public String connectionStrPostfix()
	{
		return ";sql.enforce_strict_size=true";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:hsqldb:file:Hsqldb/";
	}
}
