package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Dialect;
import com.logntw.eva.sql.dialect.Informix_Dialect;

public class InformixConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("com.informix.jdbc.IfxDriver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCIIr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "com.informix.jdbc.IfxDriver";
	}
		
	public InformixConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public InformixConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public InformixConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public InformixConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "NEWLOCALE=en_us,zh_tw;NEWCODESET=Big5,8859-1,819;";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:informix-sqli:";
	}
	
	@Override
	public Dialect getDialect()
	{
		return Informix_Dialect.INSTANCE;
	}
}