package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Dialect;
import com.logntw.eva.sql.dialect.PostgreSQLDialect;

public class PostgreSQLConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("org.postgresql.Driver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCIPr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "org.postgresql.Driver";
	}
		
	public PostgreSQLConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public PostgreSQLConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public PostgreSQLConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public PostgreSQLConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:postgresql:";
	}
	
	@Override
	public Dialect getDialect()
	{
		return PostgreSQLDialect.INSTANCE;
	}
}