package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Dialect;
import com.logntw.eva.sql.dialect.SybaseAnywhereDialect;

public class SybaseAnywhere_11ConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("sybase.jdbc.sqlanywhere.IDriver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCISr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "sybase.jdbc.sqlanywhere.IDriver";
	}
		
	public SybaseAnywhere_11ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public SybaseAnywhere_11ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public SybaseAnywhere_11ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public SybaseAnywhere_11ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:sqlanywhere:";
	}
	
	@Override
	public Dialect getDialect()
	{
		return SybaseAnywhereDialect.INSTANCE;
	}
}