package com.logntw.eva.orm.defo.conn;

import java.sql.SQLException;

import com.logntw.eva.orm.AbstractConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;
import com.logntw.eva.sql.dialect.Dialect;
import com.logntw.eva.sql.dialect.Sybase_ASE15_Dialect;

public class Sybase_ASE15ConnectionProvider extends AbstractConnectionProvider
{
	static
	{
		try
		{
			Class.forName("com.sybase.jdbc2.jdbc.SybDriver");
		}
		catch (ClassNotFoundException e)
		{
			throw new IllegalStateException(new StringBuilder("[cCISr1001]").append(e.getMessage()).toString(),e);
		}
	}
	
	@Override
	public String driverClassName()
	{
		return "com.sybase.jdbc2.jdbc.SybDriver";
	}
		
	public Sybase_ASE15ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public Sybase_ASE15ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public Sybase_ASE15ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public Sybase_ASE15ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	@Override
	public String connectionStrPostfix()
	{
		return "";
	}

	@Override
	public String connectionStrPrifix()
	{
		return "jdbc:sybase:Tds:";
	}
	
	@Override
	public Dialect getDialect()
	{
		return Sybase_ASE15_Dialect.INSTANCE;
	}
}