package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;


public class Access_7_0_Dialect extends Dialect
{	
	public final static Access_7_0_Dialect INSTANCE = new Access_7_0_Dialect();	
	public Access_7_0_Dialect()
	{
		indexable(JDBCClazz.BIT, "BIT");
		indexable(JDBCClazz.TINYINT, "BYTE");
		indexable(JDBCClazz.SMALLINT, "SMALLINT");
		indexable(JDBCClazz.INTEGER, "INTEGER", "COUNTER");
		
		indexable(JDBCClazz.REAL, "REAL");
		
		indexable(JDBCClazz.DOUBLE, "DOUBLE");
		indexable(JDBCClazz.NUMERIC, "CURRENCY");
		
		indexable(JDBCClazz.CHAR, "CHAR(N)");			
		indexable(JDBCClazz.VARCHAR, "VARCHAR(N)");
		notIndexable(JDBCClazz.LONGVARCHAR, "LONGCHAR");
		indexable(JDBCClazz.BINARY, "BINARY(N)");
		indexable(JDBCClazz.VARBINARY, "VARBINARY(N)");
		notIndexable(JDBCClazz.LONGVARBINARY, "LONGBINARY");
		
		
		indexable(JDBCClazz.TIMESTAMP, "DATETIME");				
	}
	
	@Override
	public String name()
	{		
		return "access7.0";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "autoincrement";		
	}
	
	@Override
	public String getWriteLockString(int timeout) 
	{
		throw new java.lang.UnsupportedOperationException("[dCIAt1001]");
	}
}
