package com.logntw.eva.sql.dialect;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class DialectManager
{
	protected final Map<String, Dialect> dialects = new HashMap<String, Dialect>();
	
	public void register(Dialect dialect)
	{		
		dialects.put(dialect.name(), dialect);
	}
	
	public int size()
	{
		return dialects.size();
	}
	
	public Dialect fromName(String name)
	{
		return dialects.get(name);
	}
	
	public Set<String> dialects()
	{
		return dialects.keySet();
	}
}
