package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class HSQLDB_1_8_Dialect extends Dialect
{
	public static final HSQLDB_1_8_Dialect INSTANCE = new HSQLDB_1_8_Dialect();
	public HSQLDB_1_8_Dialect()
	{
		//Cannot handle JDBCClazz.REAL? (float in java)
		indexable( JDBCClazz.BIGINT, "bigint" );
		indexable( JDBCClazz.BINARY, "binary(N)" );
		indexable( JDBCClazz.BIT, "bit" );
		indexable( JDBCClazz.BOOLEAN, "boolean" );
		indexable( JDBCClazz.CHAR, "char(N)" );
		indexable( JDBCClazz.DATE, "date" );

		indexable( JDBCClazz.DECIMAL, "decimal(N,M)" );
		indexable( JDBCClazz.DOUBLE, "double" );
		indexable( JDBCClazz.FLOAT, "float" );  // actually double
		indexable( JDBCClazz.INTEGER, "integer" );
		notIndexable( JDBCClazz.LONGVARBINARY, "longvarbinary" );
		notIndexable( JDBCClazz.LONGVARCHAR, "longvarchar" );
		indexable( JDBCClazz.SMALLINT, "smallint" );
		indexable( JDBCClazz.TINYINT, "tinyint" );
		indexable( JDBCClazz.TIME, "time" );
		indexable( JDBCClazz.TIMESTAMP, "timestamp" );
		indexable( JDBCClazz.VARCHAR, "varchar(N)" );
		indexable( JDBCClazz.VARBINARY, "varbinary(N)" );

		indexable( JDBCClazz.NUMERIC, "numeric" );
		
		notIndexable( JDBCClazz.BLOB, "longvarbinary" );
		notIndexable( JDBCClazz.CLOB, "longvarchar" );

	}
	
	@Override
	public String name()
	{		
		return "hsqldb1.8";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "generated by default as identity (start with 1)";
	}	
	
	@Override
	public boolean supportsLimit() 
	{
		return true;
	}
	
	@Override
	public StringBuilder getLimitStringStart(StringBuilder selectStmt) 
	{	
		return selectStmt.insert(6, " limit ? ?");
	}
	
	@Override
	public boolean bindLimitParametersFirst()
	{
		return true;
	}
	
		
	@Override
	public String getWriteLockString(int timeout) 
	{
		throw new java.lang.UnsupportedOperationException("[dCIHt1001]");
	}
	
	@Override
	public SubConditionSQL deleteWithSubCondition()
	{
		return SubConditionSQL.IN;
	}
	
	@Override
	public ReturnGeneratedKeys returnGeneratedKeys()
	{
		return ReturnGeneratedKeys.NEVER;
	}
}
