package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class Informix_Dialect extends Dialect
{	
	public static final Informix_Dialect INSTANCE = new Informix_Dialect();
	public Informix_Dialect()
	{		
		indexable(JDBCClazz.BIGINT, "int8");
		indexable(JDBCClazz.BINARY, "byte");
		indexable(JDBCClazz.BIT, "smallint"); // Informix doesn't have a bit type
		indexable(JDBCClazz.CHAR, "char(N)");
		indexable(JDBCClazz.DATE, "date");
		indexable(JDBCClazz.DECIMAL, "decimal");
		indexable(JDBCClazz.DOUBLE, "float");
		indexable(JDBCClazz.FLOAT, "smallfloat");
		indexable(JDBCClazz.INTEGER, "integer");
		notIndexable(JDBCClazz.LONGVARBINARY, "blob"); // or BYTE
		notIndexable(JDBCClazz.LONGVARCHAR, "clob"); // or TEXT?
		indexable(JDBCClazz.NUMERIC, "decimal"); // or MONEY
		indexable(JDBCClazz.REAL, "smallfloat");
		indexable(JDBCClazz.SMALLINT, "smallint");
		indexable(JDBCClazz.TIMESTAMP, "datetime year to fraction(5)");
		indexable(JDBCClazz.TIME, "datetime hour to second");
		indexable(JDBCClazz.TINYINT, "smallint");
		indexable(JDBCClazz.VARBINARY, "byte");
		indexable(JDBCClazz.VARCHAR, "varchar(N)", "lvarchar(N)");
	}
	
	@Override
	public String name()
	{		
		return "informix";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "serial not null";
	}

	@Override
	public StringBuilder getLimitStringStart(StringBuilder querySelect) 
	{		
		throw new UnsupportedOperationException( "[dCIIt1001]query result offset is not supported" );		
	}
}
