package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class MySQL_5_Dialect extends Dialect
{	
	public final static MySQL_5_Dialect INSTANCE = new MySQL_5_Dialect();

	public MySQL_5_Dialect()
	{		
		indexable( JDBCClazz.BIT, "bit" );
		indexable( JDBCClazz.BIGINT, "bigint" );
		indexable( JDBCClazz.SMALLINT, "smallint" );
		indexable( JDBCClazz.TINYINT, "tinyint" );
		indexable( JDBCClazz.INTEGER, "integer" );
		indexable( JDBCClazz.CHAR, "char(1)" );
		indexable( JDBCClazz.REAL, "float" );
		indexable( JDBCClazz.DOUBLE, "double precision" );
		indexable( JDBCClazz.DATE, "date" );
		indexable( JDBCClazz.TIME, "time" );
		indexable( JDBCClazz.TIMESTAMP, "datetime" );
		notIndexable( JDBCClazz.VARBINARY, 
				"tinyblob", "blob", "mediumblob", "longblob");
		notIndexable( JDBCClazz.LONGVARBINARY, "mediumblob", "longblob");
		indexable( JDBCClazz.NUMERIC, "decimal(N,M)" );
		notIndexable( JDBCClazz.BLOB, "longblob" );
		notIndexable( JDBCClazz.CLOB, "longtext" );
		indexable( JDBCClazz.VARCHAR, "varchar(N)", "longtext");
		notIndexable( JDBCClazz.LONGVARCHAR, "longtext" );
	}

	@Override
	public String name()
	{		
		return "mysql5";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "not null auto_increment"; //starts with 1, implicitly
	}
	
	@Override
	public boolean supportsLimit() 
	{
		return true;
	}
	
	@Override
	public StringBuilder getLimitStringEnd(StringBuilder sqlStmt) 
	{
		return sqlStmt.append(" limit ? , ?");				
	}
	
		@Override
	public String getReadLockString(int timeout) 
	{
		return " lock in share mode";
	}		
	
	@Override
	public SubConditionSQL updateWithSubCondition()
	{
		return SubConditionSQL.JOIN_FIRST;
	}
	
	@Override
	public SubConditionSQL deleteWithSubCondition()
	{
		return SubConditionSQL.JOIN_FIRST;
	}
			
	@Override
	public ReturnGeneratedKeys returnGeneratedKeys()
	{
		return ReturnGeneratedKeys.INSERT;
	}
}
