package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class SQLServer_2005_Dialect extends Dialect
{	
	public final static SQLServer_2005_Dialect INSTANCE = new SQLServer_2005_Dialect();
	
	public SQLServer_2005_Dialect()
	{			
		//indexable( JDBCClazz.DATE, "date", "datetime" );
		//indexable( JDBCClazz.TIME, "time", "datetime" );
		//indexable( JDBCClazz.TIMESTAMP, "datetime", "datetime2" );
	
		
		indexable( JDBCClazz.VARBINARY, "varbinary(N)", "image");
		notIndexable( JDBCClazz.LONGVARBINARY, "image" );
		notIndexable( JDBCClazz.LONGVARCHAR, "text" );
		
		
		indexable( JDBCClazz.BIT, "tinyint" ); //Sybase BIT type does not support null values
		indexable( JDBCClazz.BIGINT, "numeric(19,0)" );
		indexable( JDBCClazz.SMALLINT, "smallint" );
		indexable( JDBCClazz.TINYINT, "tinyint" );
		indexable( JDBCClazz.INTEGER, "int" );
		indexable( JDBCClazz.CHAR, "char(1)" );
		indexable( JDBCClazz.VARCHAR, "varchar(N)" );
		indexable( JDBCClazz.FLOAT, "float" );
		indexable( JDBCClazz.DOUBLE, "double precision" );
		indexable( JDBCClazz.NUMERIC, "numeric(N,M)" );
		notIndexable( JDBCClazz.BLOB, "image" );
		notIndexable( JDBCClazz.CLOB, "text" );
	}

	@Override
	public String name()
	{		
		return "sqlserver2005";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "identity not null"; //starts with 1, implicitly
	}
	
	@Override
	public String getWriteLockString(int timeout) 
	{
		throw new java.lang.UnsupportedOperationException("[dCISt1001]");
	}
	
	@Override
	public SubConditionSQL updateWithSubCondition()
	{
		return SubConditionSQL.JOIN_LAST;
	}
	
	@Override
	public SubConditionSQL deleteWithSubCondition()
	{
		return SubConditionSQL.JOIN_LAST;
	}	
}
