package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class SybaseAnywhereDialect extends Dialect
{	
	public final static SybaseAnywhereDialect INSTANCE = new SybaseAnywhereDialect();
	
	public SybaseAnywhereDialect()
	{		
		indexable( JDBCClazz.VARBINARY, "varbinary(N)", "image");
		notIndexable( JDBCClazz.LONGVARBINARY, "image" );
		notIndexable( JDBCClazz.LONGVARCHAR, "text" );
		
		
		indexable( JDBCClazz.BIT, "tinyint" ); //Sybase BIT type does not support null values
		indexable( JDBCClazz.BIGINT, "numeric(19,0)" );
		indexable( JDBCClazz.SMALLINT, "smallint" );
		indexable( JDBCClazz.TINYINT, "tinyint" );
		indexable( JDBCClazz.INTEGER, "int" );
		indexable( JDBCClazz.CHAR, "char(1)" );
		indexable( JDBCClazz.VARCHAR, "varchar(N)" );
		indexable( JDBCClazz.FLOAT, "float" );
		indexable( JDBCClazz.DOUBLE, "double precision" );
		indexable( JDBCClazz.NUMERIC, "numeric(N,M)" );
		notIndexable( JDBCClazz.BLOB, "image" );
		notIndexable( JDBCClazz.CLOB, "text" );
	}
	
	@Override
	public String name()
	{		
		return "sybase_anywhere";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "identity not null"; //starts with 1, implicitly
	}
	
	@Override
	public String getWriteLockString(int timeout) 
	{
		throw new java.lang.UnsupportedOperationException("[dCISt1001]");
	}
}
