package com.logntw.eva.sql.dialect;

import com.logntw.eva.jdbc.JDBCClazz;

public class Sybase_ASE15_Dialect extends Dialect
{	
	public final static Sybase_ASE15_Dialect INSTANCE = new Sybase_ASE15_Dialect();
	
	public Sybase_ASE15_Dialect()
	{		
		notIndexable( JDBCClazz.LONGVARBINARY, "image" );
		notIndexable( JDBCClazz.LONGVARCHAR, "text" );
		indexable( JDBCClazz.BIGINT, "bigint", "numeric(19,0)" );
		indexable( JDBCClazz.DATE, "date", "datetime" );
		indexable( JDBCClazz.DECIMAL, "numeric(N,M)" );
		indexable( JDBCClazz.TIME, "time", "datetime" );
		
		
		indexable( JDBCClazz.BIT, "tinyint" ); //Sybase BIT type does not support null values
		indexable( JDBCClazz.SMALLINT, "smallint" );
		indexable( JDBCClazz.TINYINT, "tinyint" );
		indexable( JDBCClazz.INTEGER, "int" );
		indexable( JDBCClazz.CHAR, "char(1)" );
		indexable( JDBCClazz.VARCHAR, "varchar(N)" );
		indexable( JDBCClazz.FLOAT, "float" );
		indexable( JDBCClazz.DOUBLE, "double precision" );
		indexable( JDBCClazz.TIMESTAMP, "datetime" );
		indexable( JDBCClazz.VARBINARY, "varbinary(N)" );
		indexable( JDBCClazz.NUMERIC, "numeric(N,M)" );
		notIndexable( JDBCClazz.BLOB, "image" );
		notIndexable( JDBCClazz.CLOB, "text" );
		
		
	}
	
	@Override
	public String name()
	{		
		return "sybaseASE15";
	}
	
	@Override
	public String getIdentityColumnString()
	{
		return "identity not null"; //starts with 1, implicitly
	}

	@Override
	public String getWriteLockString(int timeout) 
	{
		throw new java.lang.UnsupportedOperationException("[dCISt1001]");
	}
}
